/* Copyright 2006-2007 (C) Raster Software Vigo (Sergio Costas)
*
* This file is part of GtkPSproc
*
* GtkPSproc is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 3 of the License, or
* (at your option) any later version.
*
* GtkPSproc is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <libintl.h>
#include <locale.h>
#include <gtk/gtk.h>
#include <glade/glade.h>

#define _ gettext

#include "variables.h"

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <cups/cups.h>

//#define DEBUG_1

GString *fichero,*fichero_temporal;
GString *fichero_grupos,*fichero_a_rotar,*fichero_salida,*fichero_pares,*fichero_orden;

GError *mierror;

guint copias,preview_on=0; // 0=no preview; 1=preview odd pages; 2=preview even pages

void envia_un_trabajo();
void print_file(gchar *fichero,gchar *titulo);

void run_command(gchar *comando) {

	g_print("Running: %s\n",comando);
	system(comando);

}

void preview_file(gchar *fichero) {
	
	GString *cadena;
	
	while (g_main_context_iteration(NULL, FALSE)); // refresh screen
	cadena=g_string_new("");
	g_string_printf(cadena,"%s %s",visor_ps->str,fichero);
	run_command(cadena->str);
	g_string_free(cadena,TRUE);	
	
}

void remove_file(gchar *fichero) {

	GString *cadena;

	cadena=g_string_new("");
	g_string_sprintf(cadena,"rm %s",fichero);
	run_command(cadena->str);
	g_string_free(cadena,TRUE);
}

void finaliza(gchar todo) {

	if(!noborrar) { // if we don't want to maintain the temporal files, we delete them
			
		if(to_delete&FSALIDA)
			remove_file(fichero_salida->str);
		if(to_delete&FPARES)
			remove_file(fichero_pares->str);
		if(to_delete&FGRUPOS)
			remove_file(fichero_grupos->str);
		if(to_delete&FORDEN)
			remove_file(fichero_orden->str);
		if(to_delete&FROTAR)
			remove_file(fichero_a_rotar->str);
	}

	if(todo) { // if todo is true, exit. If not, just return
		if(to_delete&FTEMPORAL)
			remove_file(fichero_temporal->str);
		gtk_main_quit();
	} else
		to_delete&=FTEMPORAL;
}

void on_libro_toggled (GtkToggleButton *togglebutton, gpointer user_data) {

	GtkWidget *parimpar,*agrupa,*combo_agrupa;
	gint estado;

	if(GTK_TOGGLE_BUTTON (togglebutton)->active)
		estado=FALSE; // inactivate the other widgets
	else
		estado=TRUE; // activate the other widgets

	parimpar=glade_xml_get_widget(xml,"parimpar");
	agrupa=glade_xml_get_widget(xml,"agrupa");
	combo_agrupa=glade_xml_get_widget(xml,"combo_agrupa");
	
	if(!estado) {
		//gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(parimpar),TRUE);
		gtk_entry_set_text(GTK_ENTRY(agrupa),"2");
	}

	//gtk_widget_set_sensitive(parimpar,estado);
	gtk_widget_set_sensitive(combo_agrupa,estado);
		
}


// sends the document to the printer

void on_aceptar_clicked (GtkButton *button, gpointer user_data) {

	gchar separar=0,libro=0;
	const gchar *hojas;
	gchar *impresora;
	GtkWidget *entrada,*etiqueta;
	GString *comando,*titulo;
	guint bucle;
	char *finput;
	gint retorno;
	
	GtkWidget *midialogo,*label;

	save_config();

	if (preview_on==0) {

	wprinterdialog = (GtkPrintUnixDialog *)gtk_print_unix_dialog_new(_("Printer dialog"),NULL);

	gtk_print_unix_dialog_set_manual_capabilities(wprinterdialog,GTK_PRINT_CAPABILITY_GENERATE_PDF|GTK_PRINT_CAPABILITY_GENERATE_PS);

	if (GTK_RESPONSE_CANCEL==gtk_dialog_run(GTK_DIALOG(wprinterdialog))) {
		gtk_widget_destroy(GTK_WIDGET(wprinterdialog));
		wprinterdialog=NULL;
		g_print("cancel\n");
		return;
	}
	
	gtk_widget_hide(mainwindow);
	
	g_print("OK\n");

	gtk_widget_hide(GTK_WIDGET(wprinterdialog));

	impresora_actual = gtk_print_unix_dialog_get_selected_printer(wprinterdialog);

	if (NULL==set_printer((guchar *)gtk_printer_get_name(impresora_actual),configuration_list)) {
		midialogo = gtk_dialog_new_with_buttons (_("Printer not configured"),
                                                  GTK_WINDOW(wprinterdialog),
                                                  GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
                                                  GTK_STOCK_OK,
                                                  GTK_RESPONSE_ACCEPT,
                                                  GTK_STOCK_CANCEL,
                                                  GTK_RESPONSE_REJECT,
                                                  NULL);

		label = gtk_label_new (_("This printer isn't configured. Continue?"));
		gtk_container_add (GTK_CONTAINER (GTK_DIALOG(midialogo)->vbox),label);
		gtk_widget_show_all (midialogo);

		if (GTK_RESPONSE_ACCEPT!=gtk_dialog_run(GTK_DIALOG(midialogo))) {
			gtk_widget_destroy(midialogo);
			return;
		}
		gtk_widget_destroy(midialogo);
	}
	}
	hoja_actual = gtk_print_unix_dialog_get_page_setup(wprinterdialog);
	conf_actual = gtk_print_unix_dialog_get_settings(wprinterdialog);
	
	// create a non_repeated file name

	fichero_grupos=g_string_new("");
	g_string_sprintf(fichero_grupos,"%s_grupos.ps",fichero->str);
	fichero_a_rotar=g_string_new("");
	g_string_sprintf(fichero_a_rotar,"%s_rotado.ps",fichero->str);
	fichero_salida=g_string_new("");
	g_string_sprintf(fichero_salida,"%s_salida.ps",fichero->str);
	fichero_pares=g_string_new("");
	g_string_sprintf(fichero_pares,"%s_pares.ps",fichero->str);
	fichero_orden=g_string_new("");
	g_string_sprintf(fichero_orden,"%s_orden.ps",fichero->str);

	comando=g_string_new("");

	// look for the number of copies we want

	copias=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(glade_xml_get_widget(xml,"copias")));

	// asign values to boolean variables

	if(GTK_TOGGLE_BUTTON (glade_xml_get_widget(xml,"parimpar"))->active) {
		separar=1;
	}

	if (preparing_window==NULL) {
		preparing_window=glade_xml_get_widget(xml,"preparing");
	}
	etiqueta=glade_xml_get_widget(xml,"label13");

	gtk_widget_show(preparing_window);
	
	finput=ficherops->str;
	
	if(GTK_TOGGLE_BUTTON (glade_xml_get_widget(xml,"libro"))->active) {

		// want book format
		libro=1;
		
		finput=fichero_orden->str;
	
		gtk_label_set_text(GTK_LABEL(etiqueta),_("Preparing book:\nReordering pages"));
		while (g_main_context_iteration(NULL, FALSE)); // refresh screen
		while (g_main_context_iteration(NULL, FALSE)); // refresh screen
		
		g_string_sprintf(comando,"psbook -q %s %s",ficherops->str,fichero_orden->str);
		run_command(comando->str); // reorder pages
		to_delete+=FORDEN;
		gtk_label_set_text(GTK_LABEL(etiqueta),_("Preparing book:\nGrouping pages"));
		
		while (g_main_context_iteration(NULL, FALSE)); // refresh screen
		while (g_main_context_iteration(NULL, FALSE)); // refresh screen

	}

	gtk_label_set_text(GTK_LABEL(etiqueta),_("Preparing job:\nGrouping pages"));
	while (g_main_context_iteration(NULL, FALSE)); // refresh screen
	while (g_main_context_iteration(NULL, FALSE)); // refresh screen
		
	entrada=glade_xml_get_widget(xml,"agrupa");
	hojas=gtk_entry_get_text(GTK_ENTRY(entrada));

	if(hojas[0]!='1') { // group pages
		g_string_sprintf(comando,"psnup -w%d -h%d -%s -m%d -q %s %s",thepapersize.width,thepapersize.heigth,hojas,((int)margen),finput,fichero_a_rotar->str);
		run_command(comando->str);
		to_delete+=FGRUPOS;
	} else 
		g_string_sprintf(fichero_a_rotar,"%s",finput); // rename fichero_grupos

	if((hojas[0]=='2')||(hojas[0]=='8')) {

		// if the final pages are rotated, rotate even pages 180 degrees
		
		g_string_sprintf(comando,"pstops -q \"2:0,1U(%d,%d)\" %s %s",thepapersize.width,thepapersize.heigth,fichero_a_rotar->str,fichero_grupos->str);
		run_command(comando->str);
		to_delete+=FROTAR;
		
	} else {
		g_string_sprintf(fichero_grupos,"%s",fichero_a_rotar->str); // rename fichero_grupos
	}
	
	if(separar) { // double-side printing
		gtk_label_set_text(GTK_LABEL(etiqueta),_("Preparing job:\nGetting odd pages"));
		while (g_main_context_iteration(NULL, FALSE)); // refresh screen
		while (g_main_context_iteration(NULL, FALSE)); // refresh screen
		
		if(configuracion&0x02)
			g_string_sprintf(comando,"pstops 2:-0 %s %s",fichero_grupos->str,fichero_salida->str); // invert odd pages
		else
			g_string_sprintf(comando,"pstops 2:0 %s %s",fichero_grupos->str,fichero_salida->str); // don't invert odd pages
		run_command(comando->str);
		
		gtk_label_set_text(GTK_LABEL(etiqueta),_("Preparing job:\nGetting even pages"));
		while (g_main_context_iteration(NULL, FALSE)); // refresh screen
		while (g_main_context_iteration(NULL, FALSE)); // refresh screen
		
		if(configuracion&0x04)
			g_string_sprintf(comando,"pstops 2:-1 %s %s",fichero_grupos->str,fichero_pares->str); // invert even pages
		else
			g_string_sprintf(comando,"pstops 2:1 %s %s",fichero_grupos->str,fichero_pares->str); // don't invert even pages
		run_command(comando->str);
		to_delete+=(FSALIDA+FPARES);
	} else {
		if(configuracion&0x01) {
			
			gtk_label_set_text(GTK_LABEL(etiqueta),_("Preparing job:\nInverting pages"));
			while (g_main_context_iteration(NULL, FALSE)); // refresh screen
			while (g_main_context_iteration(NULL, FALSE)); // refresh screen
			
			g_string_sprintf(comando,"pstops 1:-0 %s %s",fichero_grupos->str,fichero_salida->str); // invert all pages
			run_command(comando->str);
			to_delete+=FSALIDA;
		} else
			g_string_sprintf(fichero_salida,"%s",fichero_grupos->str); // rename fichero_salida
	}

	g_string_free(comando,TRUE);
	
	switch(preview_on) {
	case 0: // no preview
		
		copias_final_odd = copias;
		if (separar) {
			gtk_label_set_text(GTK_LABEL(etiqueta),_("Sending odd pages\nto the printer"));
			while (g_main_context_iteration(NULL, FALSE)); // refresh screen
			while (g_main_context_iteration(NULL, FALSE)); // refresh screen
			copias_final_even = copias;
		} else {
			gtk_label_set_text(GTK_LABEL(etiqueta),_("Sending job to the printer"));
			while (g_main_context_iteration(NULL, FALSE)); // refresh screen
			while (g_main_context_iteration(NULL, FALSE)); // refresh screen
			copias_final_even = 0;
		}
		dialogo = FALSE;
		
		envia_un_trabajo();
		
	break;
	case 1: // preview odd pages or document itself
		gtk_widget_hide(preparing_window);
		preview_file(fichero_salida->str);
		preview_on=0;
		finaliza(0);
	break;
	case 2: // preview even pages
		gtk_widget_hide(preparing_window);
		preview_file(fichero_pares->str);
		preview_on=0;
		finaliza(0);
	break;
	}
}


void envia_un_trabajo() {

	GString *titulo;
	show_error("Imprimo: ");

	if (copias_final_odd) {
		copias_final_odd--;
		if (copias_final_even) {
			titulo=g_string_new("");
			g_string_printf(titulo,_("%s (odd pages)"),job_ps->str);
			print_file(fichero_salida->str,titulo->str);
		} else {
			print_file(fichero_salida->str,job_ps->str);
		}
	} else {
		if (copias_final_even) {
			if (dialogo) {
				copias_final_even--;
				titulo=g_string_new("");
				g_string_printf(titulo,_("%s (even pages)"),job_ps->str);
				print_file(fichero_pares->str,titulo->str);
			} else {
				gtk_widget_hide(preparing_window);
				evenpagesOK = glade_xml_get_widget(xml,"evenpagesOK");
				gtk_widget_show (evenpagesOK);
			}
		} else {
			finaliza(1);
		}
	}

}

void envio_finalizado (GtkPrintJob *print_job,gpointer user_data,GError *error) {

	envia_un_trabajo();

}

void print_file(gchar *fichero,gchar *titulo) {

	// prints the file to the desired printer

	const gchar *impresora;
	GtkPrintJob *trabajo;
	
	trabajo = gtk_print_job_new(titulo,impresora_actual,conf_actual,hoja_actual);
	gtk_print_job_set_source_file (trabajo,fichero,&mierror);
	gtk_print_job_send(trabajo,envio_finalizado,NULL,NULL);

}


void on_about_clicked (GtkButton *button, gpointer user_data) {

	printf("About\n");

	if(about_window==NULL)
		about_window=glade_xml_get_widget(xml,"about_window");
	else
		gtk_widget_hide (about_window);
	gtk_widget_show(about_window);
}


void on_evenok_clicked (GtkButton *button, gpointer user_data) {

	GtkWidget *etiqueta;
	etiqueta=glade_xml_get_widget(xml,"label13");

	dialogo = TRUE;
	gtk_widget_hide (evenpagesOK);
	
	gtk_label_set_text(GTK_LABEL(etiqueta),_("Sending even pages\nto the printer"));
	gtk_widget_show (preparing_window);
	while (g_main_context_iteration(NULL, FALSE)); // refresh screen
	while (g_main_context_iteration(NULL, FALSE)); // refresh screen
	
	envia_un_trabajo();

}

void check_for_visor() {

	GString *cadena;
	
	if(check_visor(visor_ps->str)) { // if true, the file doesn't exist
		cadena=g_string_new("");
		noviewer2_window=glade_xml_get_widget(xml,"noviewer2");
		g_string_printf(cadena,_("Can't find the PS viewer %s. Preview will be unavailable until you configure a new viewer."),visor_ps->str);
		gtk_label_set(GTK_LABEL(glade_xml_get_widget(xml,"label_noview")),cadena->str);
		gtk_widget_show(noviewer2_window);
		viewer_found=0;
		g_string_free(cadena,TRUE);
	} else
		viewer_found=1;
}




void on_preview_odd_clicked (GtkButton *button, gpointer user_data) {

	preview_on=1;
	on_aceptar_clicked (NULL,NULL);
}


void on_preview_even_clicked (GtkButton *button, gpointer user_data) {
	
	preview_on=2;
	on_aceptar_clicked (NULL,NULL);
}

void on_noviewer_clicked (GtkButton *button, gpointer user_data) {
	
	gtk_widget_hide(noviewer_window);
}


void on_noviewer2_clicked (GtkButton *button, gpointer user_data) {
	
	gtk_widget_hide(noviewer2_window);
	noviewer2_window=NULL;
}

void on_parimpar_toggled (GtkToggleButton *togglebutton, gpointer user_data) {
	
	set_preview_buttons();
}
