#ifndef H_GLOBAL
#define H_GLOBAL

#define DEBUG

#include <gtk/gtkprintunixdialog.h>

#define FTEMPORAL 1
#define FGRUPOS 2
#define FSALIDA 4
#define FPARES 8
#define FORDEN 16
#define FROTAR 32

#define BOUNDINGBOX 1
#define BOUNDIGATEND 2
#define DOCPAPERSIZES 4
#define DOCUMENTMEDIA 8
#define PAGESIZE 16

struct printer_conf {
	
	GString *name;
	guchar configuracion;
	guchar configurada;
	guchar isdefault;
	guchar margen;
	struct printer_conf *next;

};

struct pssize {
	
	gint pwidth,pheigth; // width & heigth based on PAPERTYPE
	gint dwidth,dheigth; // width & heigth based on DOCUMENTMEDIA
	gint bwidth,bheigth; // width & heigth based on BOUNDINGBOX
	gint swidth,sheigth; // width & heigth based on BEGINFEATURE: *PAGESIZE
	gint found; // values found
	gint width,heigth; // final value decided from the best of three
};

struct papertypes {
	gchar *name;
	gint width;
	gint heigth;
};

extern GtkWidget *mainwindow;
extern GtkWidget *evenpagesOK;
extern GtkWidget *about_window;
extern GtkWidget *first_time_window;
extern GtkWidget *config_window;
extern GtkWidget *preparing_window;
extern GtkWidget *noviewer_window;
extern GtkWidget *noviewer2_window;

extern GtkPrintUnixDialog *wprinterdialog;
extern GtkPrinter *impresora_actual;
extern GtkPageSetup *hoja_actual;
extern GtkPrintSettings *conf_actual;
extern GtkWidget *wconfprinter;
extern gint num_copias;
extern gint copias_final_odd;
extern gint copias_final_even;
extern gboolean dialogo;

extern GString *ficherops;
extern GString *parametros,*visor_ps,*job_ps;
extern GString *fichero;
extern GString *fichero_temporal;
extern guchar configuracion,margen,first_time;

extern gint to_delete,viewer_found;
extern guchar noborrar;

extern GladeXML *xml;

extern struct printer_conf *configuration_list,*temp_config_list;

extern struct pssize thepapersize;

void run_command(gchar *);
void save_config();
int check_visor(gchar *);
void set_preview_buttons();
void check_for_visor();
struct printer_conf *set_printer(guchar *printer_name,struct printer_conf *list);
void set_values_config();
int get_ps_size(GString *filename,struct pssize *ps_size);
void show_error(char *mensaje);
#endif
